---
title: RTCIceCandidate
slug: Web/API/RTCIceCandidate
tags:
  - API
  - Candidate
  - Connection
  - Connectivity
  - ICE
  - Interface
  - Media
  - RTCIceCandidate
  - Reference
  - SDP
  - Web RTC
  - WebRTC
  - WebRTC API
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong><code>RTCIceCandidate</code></strong> interface—part of the <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a>—represents a candidate Internet Connectivity Establishment ({{Glossary("ICE")}}) configuration which may be used to establish an {{domxref("RTCPeerConnection")}}.</span></p>

<p>An ICE candidate describes the protocols and routing needed for WebRTC to be able to communicate with a remote device. When starting a WebRTC peer connection, typically a number of candidates are proposed by each end of the connection, until they mutually agree upon one which describes the connection they decide will be best. WebRTC then uses that candidate's details to initiate the connection.</p>

<p>For details on how the ICE process works, see <a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a>. The article <a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a> provides additional useful details.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("RTCIceCandidate.RTCIceCandidate()","RTCIceCandidate()")}}</dt>
	<dd>Creates an <code>RTCIceCandidate</code> object to represent a single ICE candidate, optionally configured based on an object based on the {{domxref("RTCIceCandidateInit")}} dictionary.
	<div class="note"><strong>Note:</strong> For backward compatibility, the constructor also accepts as input a string containing the value of the {{domxref("RTCIceCandidate.candidate", "candidate")}} property instead of a {{domxref("RTCIceCandidateInit")}} object, since the <code>candidate</code> includes all of the information that <code>RTCIceCandidateInit</code> does and more.</div>
	</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref("RTCIceCandidate.candidate", "candidate")}} {{readonlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} representing the transport address for the candidate that can be used for connectivity checks. The format of this address is a <code>candidate-attribute</code> as defined in {{RFC(5245)}}. This string is empty (<code>""</code>) if the <code>RTCIceCandidate</code> is an "end of candidates" indicator.</dd>
	<dt>{{domxref("RTCIceCandidate.component", "component")}} {{ReadOnlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} which indicates whether the candidate is an RTP or an RTCP candidate; its value is either <code>"rtp"</code> or <code>"rtcp"</code>, and is derived from the  <code>"component-id"</code> field in the <code>candidate</code> a-line string. The permitted values are listed in the {{domxref("RTCIceComponent")}} enumerated type.</dd>
	<dt>{{domxref("RTCIceCandidate.foundation", "foundation")}} {{readonlyInline}}</dt>
	<dd>Returns a {{domxref("DOMString")}} containing a unique identifier that is the same for any candidates of the same type, share the same base (the address from which the ICE agent sent the candidate), and come from the same {{Glossary("STUN")}} server. This is used to help optimize ICE performance while prioritizing and correlating candidates that appear on multiple {{domxref("RTCIceTransport")}} objects.</dd>
	<dt>{{domxref("RTCIceCandidate.ip", "ip")}} {{readonlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} containing the IP address of the candidate.</dd>
	<dt>{{domxref("RTCIceCandidate.port", "port")}} {{readonlyInline}}</dt>
	<dd>An integer value indicating the candidate's port number.</dd>
	<dt>{{domxref("RTCIceCandidate.priority", "priority")}} {{readonlyInline}}</dt>
	<dd>A long integer value indicating the candidate's priority.</dd>
	<dt>{{domxref("RTCIceCandidate.address", "address")}} {{readonlyInline}}</dt>
	<dd>The address of the candidate.</dd>
	<dt>{{domxref("RTCIceCandidate.protocol", "protocol")}} {{readonlyInline}}</dt>
	<dd>A string indicating whether the candidate's protocol is <code>"tcp"</code> or <code>"udp"</code>. The string is one of those in the enumerated type <code>RTCIceProtocol</code>.</dd>
	<dt>{{domxref("RTCIceCandidate.relatedAddress", "relatedAddress")}} {{readonlyInline}}</dt>
	<dd>If the candidate is derived from another candidate, <code>relatedAddress</code> is a {{domxref("DOMString")}} containing that host candidate's IP address. For host candidates, this value is <code>null</code>.</dd>
	<dt>{{domxref("RTCIceCandidate.relatedPort", "relatedPort")}} {{readonlyInline}}</dt>
	<dd>For a candidate that is derived from another, such as a relay or reflexive candidate, the <code><dfn>relatedPort</dfn></code> is a number indicating the port number of the candidate from which this candidate is derived. For host candidates, the <code>relatedPort</code> property is <code>null</code>.</dd>
	<dt>{{domxref("RTCIceCandidate.sdpMid", "sdpMid")}} {{readonlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} specifying the candidate's media stream identification tag which uniquely identifies the media stream within the component with which the candidate is associated, or <code>null</code> if no such association exists.</dd>
	<dt>{{domxref("RTCIceCandidate.sdpMLineIndex", "sdpMLineIndex")}} {{readonlyInline}}</dt>
	<dd>If not <code>null</code>, <code>sdpMLineIndex</code> indicates the zero-based index number of the media description (as defined in <a href="https://tools.ietf.org/html/rfc4566">RFC 4566</a>) in the {{Glossary("SDP")}} with which the candidate is associated.</dd>
	<dt>{{domxref("RTCIceCandidate.tcpType", "tcpType")}} {{readonlyInline}}</dt>
	<dd>If <code>protocol</code> is <code>"tcp"</code>, <code>tcpType</code> represents the type of TCP candidate. Otherwise, <code>tcpType</code> is <code>null</code>.</dd>
	<dt>{{domxref("RTCIceCandidate.type", "type")}} {{readonlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} indicating the type of candidate as one of the strings from the {{domxref("RTCIceCandidateType")}} enumerated type.</dd>
	<dt>{{domxref("RTCIceCandidate.usernameFragment", "usernameFragment")}} {{ReadOnlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} containing a randomly-generated username fragment ("ice-ufrag") which ICE uses for message integrity along with a randomly-generated password ("ice-pwd"). You can use this string to verify generations of ICE generation; each generation of the same ICE process will use the same <code>usernameFragment</code>, even across ICE restarts.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref("RTCIceCandidate.toJSON", "toJSON()")}}</dt>
	<dd>Given the <code>RTCIceCandidate</code>'s current configuration, <code>toJSON()</code> returns a {{domxref("DOMString")}} containing a {{Glossary("JSON")}} representation of that configuration in the form of a {{domxref("RTCIceCandidateInit")}} object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>For examples, see the article <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>, which demonstrates the entire process.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('WebRTC 1.0', '#rtcicecandidate-interface', 'RTCIceCandidate')}}</td>
			<td>{{Spec2('WebRTC 1.0')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceCandidate")}}</p>
</div>
